#!/bin/sh
# 
# SamyGO ForceFirmwareBack v.CIP 0.2.4.1 by juzis28
# last update on 21/11/2012
#
ver=CIP_0.2.4.1
set -e # urgent script exit if any command returns error
start=`date +%s`
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"

# search for USB
if [ -e /dtv/usb/sda ]; then
		USB=/dtv/usb/sda

elif [ -e /dtv/usb/sda1 ]; then
        USB=/dtv/usb/sda1

elif [ -e /dtv/usb/sda2 ]; then
        USB=/dtv/usb/sda2

elif [ -e /dtv/usb/sdb ]; then
        USB=/dtv/usb/sdb

elif [ -e /dtv/usb/sdb1 ]; then
        USB=/dtv/usb/sdb1
		
elif [ -e /dtv/usb/sdc ]; then
        USB=/dtv/usb/sdc
		
elif [ -e /dtv/usb/sdc1 ]; then
        USB=/dtv/usb/sdc1
else
	echo "[`date +%H:%M:%S`] No valid USB found. Script stop. Exit. Rebooting..."
	touch /mtd_swu/NO_USB    # Flag file for screen message - no USB found
	sleep 10
	exit 2
fi

#set _Function for reboot on error and on script exit/end
_Func_Error () 
{
sleep 10
echo "ERROR ERROR ERROR ERROR "
echo "Reboot on error or script end."
	/mtd_boot/MicomCtrl 143  
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
}
trap _Func_Error EXIT

#Check USB filesystem. Only Fat32 is ok.
if [ `mount | grep $USB | grep -c "type ntfs"` == 1 ]; then
		touch /mtd_swu/0_wrong_usb_fs    # flag file for screen message - wrong usb file system (NTFS)
		echo "Wrong USB file system. Fat32 is needed. . . ! ! !"
		sleep 10
		error
fi 

########################## variables ########################
FFBLOG=$USB/_FFBlog.log
SYSLOG=$USB/_sysinfo.log

EXE_PART0=/dev/bml0/8
EXE_PART1=/dev/bml0/10
EXE_DEPO=/mtd_swu/exe.img
APPDATA_PART0=/dev/bml0/9
APPDATA_PART1=/dev/bml0/11
APPDATA_DEPO=/mtd_swu/appdata.img
md5_macpart_CHL20060="4f57be6bee4f19740bbfd5864d802322"
md5_macpart_CHU6CIPDSEUC10080="e842e04b21523177d64ce78c2e74ea95"
#md5_macpart_CHL20050="not supported yet"
#md5_macpart_CHL20048="not supported yet"
md5_macpart_CHU30000="82f3703b0f0e35cbba2df0a95a3931a5"
md5_MacPart="not defined"

EXE_PART=""
APPDATA_PART=""
MAC_PART0="not needed"
MAC_PART1="not needed"
MAC_PART="not needed"
VERSION=""
VERSION_ALT=""
PART_FLAG=""
PART_FLAG_ALT=""

#clean /mtd_swu
set +e
echo "cleaning /mtd_swu/" 
rm -rf /mtd_swu/* 
echo "/mtd_swu/ cleaned." 
set -e

#kill watchdog 
/mtd_boot/MicomCtrl 23 
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23


#script debug
export PS4='+'
exec > $USB/_debug.log
exec 2>&1
set -x # debug script file to _debug.log
#

# Collecting system information
echo "==========FFB ver. $ver by juzis28=========="> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "==========Some important system information==========">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
cat /.info >> $FFBLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "========================mount=======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	mount >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "========================df -h=======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	df -h >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "===================PartitionSwitch*=================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	ls -1 /mtd_rwarea/PartitionSwitch* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "======================Version*======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	ls -1 /mtd_rwarea/Version* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	cat /mtd_rwarea/Version* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "=========================end========================" >> $SYSLOG 2>&1


echo "==============FFB ver. $ver by juzis28=============="> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1 
echo "=====================Script start====================" >> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1 
echo "USB found: $USB"
echo "USB found: $USB" >> $FFBLOG 2>&1 


# search for directory
#CI+ firmwares
if [ -d $USB/T-CHLCIPDEUC ]; then
	MODE=CIP
	firmware_usb=T-CHLCIPDEUC
	image_dir=$firmware_usb/image
	MAC_PART0=/dev/bml0/18
	MAC_PART1=/dev/bml0/19
	MacKeyPART=/dev/bml0/20
elif [ -d $USB/T-CHL6CIPDSEUC ]; then
	MODE=CIP
	firmware_usb=T-CHL6CIPDSEUC
	image_dir=$firmware_usb/image
	MAC_PART0=/dev/bml0/18
	MAC_PART1=/dev/bml0/19
	MacKeyPART=/dev/bml0/20
elif [ -d $USB/T-CHUCIPDEUC ]; then
	MODE=CIP
	firmware_usb=T-CHUCIPDEUC
	image_dir=$firmware_usb/image
	MAC_PART0=/dev/bml0/16
	MAC_PART1=/dev/bml0/17
	MacKeyPART=/dev/bml0/18
else
	echo "ERROR. No firmware on USB found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
	touch /mtd_swu/1_no_fw_on_usb    # 1 flag file for screen message - no firmware on usb / wrong firmware
	_Func_Error
fi

echo " MODE is $MODE " 
touch /mtd_swu/$MODE
echo " " >> $FFBLOG 2>&1
echo " FFB operating mode is $MODE " >> $FFBLOG 2>&1
echo " " >> $FFBLOG 2>&1

#Check deeper to avoid flashing from renamed directory 
if [ $( grep -c $firmware_usb $USB/$image_dir/info.txt ) -gt 0 ]
then 
	 firmware_dir=$firmware_usb
     echo "Found: $firmware_usb firmware on USB." >> $FFBLOG 2>&1
else
	touch /mtd_swu/1_no_fw_usb    # 1 flag file for screen message - no firmware on usb / wrong firmware
	echo "ERROR. Did you rename firmware directory??? Do not do it in future, you brick your TV! Firmware mismatch! quit."  >> $FFBLOG 2>&1 
	_Func_Error
fi

#crc tool
#if [ -f /mtd_rwarea/crc ]
#	then
#		echo "[`date +%H:%M:%S`] crc found on /mtd_rwarea" >> $FFBLOG 2>&1 
#	else		
#		echo "[`date +%H:%M:%S`] crc not found, searching on $USB"  >> $FFBLOG 2>&1 
#			if [ -f $USB/$firmware_dir/crc ]
#				then
#					echo "[`date +%H:%M:%S`] crc found on $USB/$firmware_dir/, trying to copy..." >> $FFBLOG 2>&1 
#						cp -f $USB/$firmware_dir/crc /mtd_rwarea/  >> $FFBLOG 2>&1 
#						chmod 755 /mtd_rwarea/crc
#					echo "[`date +%H:%M:%S`] crc copied to /mtd_rwarea/ successfully"  >> $FFBLOG 2>&1 
#				else
#					echo "[`date +%H:%M:%S`] crc did not found on $USB/$firmware_dir/. Script stop. Exit." >> $FFBLOG 2>&1 
#					touch /mtd_swu/4_no_crc # flag file for message
#					sleep 10
#					_Func_Error
#					fi
#fi

#Check files on USB for debug
		echo " " >> $FFBLOG 2>&1
		echo "#Check files on USB " >> $FFBLOG 2>&1
		echo "Content of $USB:" >> $FFBLOG 2>&1
		ls -la $USB >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		echo "Content of $USB\/$firmware_usb\/:" >> $FFBLOG 2>&1
		ls -la $USB/$firmware_usb >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		echo "Content of $USB\/$firmware_usb\/image:" >> $FFBLOG 2>&1
		ls -la $USB/$firmware_usb/image >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1

# Check for active firmware flag and partitions.
if  [ -e /mtd_rwarea/PartitionSwitch_0_0 ]
    then
		VERSION=/mtd_rwarea/Version.0
		VERSION_ALT=/mtd_rwarea/Version.1
		PART_FLAG=/mtd_rwarea/PartitionSwitch_0_0
		PART_FLAG_ALT=/mtd_rwarea/PartitionSwitch_1_0
		EXE_PART=$EXE_PART1
		APPDATA_PART=$APPDATA_PART1
		MAC_PART=$MAC_PART1
	#Print variables to log file
		echo " " >> $FFBLOG 2>&1
		echo "VERSION is $VERSION" >> $FFBLOG 2>&1
		echo "VERSION_ALT is $VERSION_ALT" >> $FFBLOG 2>&1
		echo "PART_FLAG is $PART_FLAG" >> $FFBLOG 2>&1
		echo "PART_FLAG_ALT is $PART_FLAG_ALT" >> $FFBLOG 2>&1		
		echo "EXE_PART is $EXE_PART" >> $FFBLOG 2>&1
		echo "APPDATA_PART is $APPDATA_PART" >> $FFBLOG 2>&1
		echo "MAC_PART is $MAC_PART" >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		if  [ -e /mtd_rwarea/PartitionSwitch_1_0 ]
			then
				echo "Found PartitionSwitch_0_0 and PartitionSwitch_1_0."  >> $FFBLOG 2>&1 
					rm -rf /mtd_rwarea/PartitionSwitch_1_0
				echo "PartitionSwitch_1_0 deleted." >> $FFBLOG 2>&1 
			else
				echo "Found PartitionSwitch_0_0 only" >> $FFBLOG 2>&1 
		fi
	else
		if  [ -e /mtd_rwarea/PartitionSwitch_1_0 ]
			then
				VERSION=/mtd_rwarea/Version.1
				VERSION_ALT=/mtd_rwarea/Version.0
				PART_FLAG=/mtd_rwarea/PartitionSwitch_1_0
				PART_FLAG_ALT=/mtd_rwarea/PartitionSwitch_0_0
				EXE_PART=$EXE_PART0
				APPDATA_PART=$APPDATA_PART0
				MAC_PART=$MAC_PART0
			#Print variables to log file
				echo " " >> $FFBLOG 2>&1
				echo "VERSION is $VERSION" >> $FFBLOG 2>&1
				echo "VERSION_ALT is $VERSION_ALT" >> $FFBLOG 2>&1
				echo "PART_FLAG is $PART_FLAG" >> $FFBLOG 2>&1
				echo "PART_FLAG_ALT is $PART_FLAG_ALT" >> $FFBLOG 2>&1		
				echo "EXE_PART is $EXE_PART" >> $FFBLOG 2>&1
				echo "APPDATA_PART is $APPDATA_PART" >> $FFBLOG 2>&1
				echo "MAC_PART is $MAC_PART" >> $FFBLOG 2>&1
				echo " " >> $FFBLOG 2>&1
		fi
fi
#Check firmware on USB is compatible?
if [ $( grep -c $firmware_usb $USB/$image_dir/info.txt ) == $(grep -c $firmware_usb $VERSION ) ]
then
    firmware_dir=$firmware_usb
	touch /mtd_swu/2_fw_ok # 2 flag file for screen message - firmware ok.
    echo "Firmware on USB mach to firmware on TV. Going to upgrade..." >> $FFBLOG 2>&1
else
	touch /mtd_swu/3_fw_mismatch #3 flag file for screen message - firmware missmatch
    echo "ERROR. Wrong firmware on USB. Firmware mismatch. No firmware on USB?"
	_Func_Error
fi

#find current script dir by script name (/ffb.sh - minus 7 char)/CIP_ffb.sh - minus 11 chars
CUR_DIR=$( echo ${0} | sed 's/\(.*\).........../\1/' ) 
echo "Current script dir is $CUR_DIR " >> $FFBLOG 2>&1
#CUR_DIR=/mtd_tlib/swf/CHILDREN/firmware/FFB

#Find firmware number on USB
fw_nr=$( cat $USB/$image_dir/info.txt  | sed 's/^.*\(......\)$/\1/' )
echo "Firmware on USB is $firmware_usb-$fw_nr ">> $FFBLOG 2>&1


echo "Checking SamyGODecrypter..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/SamyGODecrypter ];	then
		echo "SamyGODecrypter found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/SamyGODecrypter >> $FFBLOG 2>&1
	else
		echo "ERROR. SamyGODecrypter not found!" >> $FFBLOG 2>&1
		_Func_Error
fi

echo "Checking md5sum..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/md5sum ];	then
		echo "md5sum found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/md5sum >> $FFBLOG 2>&1
	else
		echo "ERROR. md5sum not found!" >> $FFBLOG 2>&1
		_Func_Error
fi

if [ ! -e $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin ]; then 
		echo "ERROR. MacPart.bin not found !!!" >> $FFBLOG 2>&1
		touch /mtd_swu/MacPart_error
		_Func_Error
	else
		if [ $MODE == "CIP" ]; then
		echo "MacPart.bin found. Checking checksums... !!!" >> $FFBLOG 2>&1
		fi
fi		

echo "Checking crc..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/crc ];	then
		echo "crc found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/crc >> $FFBLOG 2>&1
	else
		echo "ERROR. crc not found!" >> $FFBLOG 2>&1
		_Func_Error
fi
#Cleaning /mtd_swu/, ignore errors
set +e
echo "[`date +%H:%M:%S`] cleaning /mtd_swu/" >> $FFBLOG 2>&1 
rm -rf /mtd_swu/* >> $FFBLOG 2>&1 
echo "[`date +%H:%M:%S`] /mtd_swu/ cleaned." >> $FFBLOG 2>&1 
set -e

#Check if original firmware is used (match chksums)
if [ $MODE == "CIP" ]; then
	if	 [ $firmware_usb == "T-CHLCIPDEUC" ] && [ $fw_nr == "2006.0" ] && [ $( grep -c "\*007_exe.img_46bfc89b\*011_appdata.img_67487d54" $USB/$image_dir/validinfo.txt ) -gt 0 ]; then
		echo "checksums of exe.img and appdata.img are OK" >> $FFBLOG 2>&1
			md5_MacPart=$md5_macpart_CHL20060
			#Checking macPart hashes
			md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
			echo $md5 > /mtd_swu/MacPart.md5
				if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
					echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
				else
					echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
					touch /mtd_swu/MacPart_error
					_Func_Error	
				fi
	elif [ $firmware_usb == "T-CHLCIPDEUC" ] && [ $fw_nr == "2005.0" ] && [ $( grep -c "\*007_exe.img_3d70f2eb\*011_appdata.img_c989c87a" $USB/$image_dir/validinfo.txt ) -gt 0 ]; then
		echo "checksums of exe.img and appdata.img are OK" >> $FFBLOG 2>&1
			md5_MacPart=$md5_macpart_CHL20050
			#Checking macPart hashes
			md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
			echo $md5 > /mtd_swu/MacPart.md5
				if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
					echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
				else
					echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
					touch /mtd_swu/MacPart_error
					_Func_Error	
				fi
	elif [ $firmware_usb == "T-CHLCIPDEUC" ] && [ $fw_nr == "2004.8" ] && [ $( grep -c "\*007_exe.img_7805a776\*011_appdata.img_a7a5f63f" $USB/$image_dir/validinfo.txt ) -gt 0 ]; then
		echo "checksums of exe.img and appdata.img are OK" >> $FFBLOG 2>&1
			md5_MacPart=$md5_macpart_CHL20048
			#Checking macPart hashes
			md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
			echo $md5 > /mtd_swu/MacPart.md5
				if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
					echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
				else
					echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
					touch /mtd_swu/MacPart_error
					_Func_Error	
				fi
	elif [ $firmware_usb == "T-CHUCIPDEUC" ] && [ $fw_nr == "3000.0" ] && [ $( grep -c "\*007_exe.img_3c14ce3d\*011_appdata.img_fcd61a77" $USB/$image_dir/validinfo.txt ) -gt 0 ]; then
		echo "checksums of exe.img and appdata.img are OK" >> $FFBLOG 2>&1
			md5_MacPart=$md5_macpart_CHU30000
			#Checking macPart hashes
			md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
			echo $md5 > /mtd_swu/MacPart.md5
				if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
					echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
				else
					echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
					touch /mtd_swu/MacPart_error
					_Func_Error	
				fi
	elif	 [ $firmware_usb == "T-CHL6CIPDSEUC" ] && [ $fw_nr == "1008.0" ] && [ $( grep -c "\*007_exe.img_a2017bb0\*011_appdata.img_0d3175b8" $USB/$image_dir/validinfo.txt ) -gt 0 ]; then
		echo "checksums of exe.img and appdata.img are OK" >> $FFBLOG 2>&1
			md5_MacPart=$md5_macpart_CHU6CIPDSEUC10080
			#Checking macPart hashes
			md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
			echo $md5 > /mtd_swu/MacPart.md5
				if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
					echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
				else
					echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
					touch /mtd_swu/MacPart_error
					_Func_Error	
				fi
	else
		echo "ERROR. checksums do not match! Patched firmware??? Not supported version?" >> $FFBLOG 2>&1
		touch /mtd_swu/checksum_error
		_Func_Error
	fi
fi

#Cleaning /mtd_swu/, ignore errors
set +e
echo "[`date +%H:%M:%S`] cleaning /mtd_swu/" >> $FFBLOG 2>&1 
rm -rf /mtd_swu/* >> $FFBLOG 2>&1 
echo "[`date +%H:%M:%S`] /mtd_swu/ cleaned." >> $FFBLOG 2>&1 
set -e

#Decrypting partitions, check md5 and flash
echo "Firmware flashing MODE is $MODE "  >> $FFBLOG 2>&1 

if [ -e $USB/$image_dir/exe.img.sec ]; then # CIP mode
#decrypting CI+ exe.img.sec and copying to mtd_swu
	echo "########## Decrypting exe.img.sec (CI+) ##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] exe.img.sec found on $USB, start decrypting..." >> $FFBLOG 2>&1 
	touch /mtd_swu/exe_decrypt_start
	$CUR_DIR/SamyGODecrypter $firmware_usb $USB/$image_dir/exe.img.sec $EXE_DEPO >> $FFBLOG 2>&1 
	touch /mtd_swu/exe_decrypt_ok
	echo "[`date +%H:%M:%S`] exe.img decrypted and copied to mtd_swu..." >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
	
#crc check of exe.img
	$CUR_DIR/crc $EXE_DEPO $USB/$image_dir/validinfo.txt
	if [ $? -ne 0 ] ; then echo "[`date +%H:%M:%S`] checksum error! Try another USB pen drive." >> $FFBLOG 2>&1 && touch /mtd_swu/crc_error && _Func_Error;fi
	echo "[`date +%H:%M:%S`] exe.img checksum ok" >> $FFBLOG 2>&1
	
#flashing exe.img
	echo "########## Flashing exe.img (CI+)##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] Start flashing to $EXE_PART "  >> $FFBLOG 2>&1 
	touch /mtd_swu/exe_flash_start 
	bml.restore $EXE_PART $EXE_DEPO > $USB/[$firmware_usb.$fw_nr]exe_img.log 2>&1
	touch /mtd_swu/exe_flash_ok
	echo "[`date +%H:%M:%S`] $EXE_PART restored. Deleting source..."  >> $FFBLOG 2>&1 
	rm -rf $EXE_DEPO
	echo "[`date +%H:%M:%S`] exe.img deleted from /mtd_swu/"  >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync
			else
				echo "ERROR. exe.img.sec not found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
				touch /mtd_swu/exe_img_error # message on error
				_Func_Error
fi
			
if [ -e $USB/$image_dir/appdata.img.sec ]; then
#decrypting CI+ image and copying to mtd_swu
	echo "########## Decrypting appdata.img.sec (CI+) ##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] appdata.img.sec found on $USB, start decrypting..." >> $FFBLOG 2>&1 
	touch /mtd_swu/appdata_decrypt_start
	$CUR_DIR/SamyGODecrypter $firmware_usb $USB/$image_dir/appdata.img.sec $APPDATA_DEPO >> $FFBLOG 2>&1 
	touch /mtd_swu/appdata_decrypt_ok 
	echo "[`date +%H:%M:%S`] appdata.img decrypted and copied to mtd_swu..." >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1

#crc check of appdata.img	
	$CUR_DIR/crc $APPDATA_DEPO $USB/$image_dir/validinfo.txt
	if [ $? -ne 0 ] ; then echo "[`date +%H:%M:%S`] checksum error! Try another USB pen drive."  >> $FFBLOG 2>&1 && touch /mtd_swu/crc_error && _Func_Error;fi 
		echo "[`date +%H:%M:%S`] appdata.img checksum ok" >> $FFBLOG 2>&1
	
#flashing appdata.img
	echo "########## Flashing appdata.img (CI+)##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] Start flashing to $APPDATA_PART "  >> $FFBLOG 2>&1 
	touch /mtd_swu/appdata_flash_start
	bml.restore $APPDATA_PART $APPDATA_DEPO > $USB/[$firmware_usb.$fw_nr]appdata_img.log 2>&1
	touch /mtd_swu/appdata_flash_ok 
	echo "[`date +%H:%M:%S`] $APPDATA_PART restored. Deleting source..."  >> $FFBLOG 2>&1 
	rm -rf $APPDATA_DEPO >> $FFBLOG 2>&1 
	echo "[`date +%H:%M:%S`] appdata.img deleted from /mtd_swu/"  >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync
			else
				echo "ERROR. appdata.img.sec not found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
				touch /mtd_swu/appdata_img_error # message on error
				_Func_Error
fi
			
#flashing MacPart.bin	
#	echo "########## Flashing hashes (CI+)##########" >> $FFBLOG 2>&1
#	echo " " >> $FFBLOG 2>&1
#	echo "[`date +%H:%M:%S`] MacPart.bin found on $USB, start copying..." >> $FFBLOG 2>&1 
#	cp -f $USB/$image_dir/[$firmware_usb-$fw_nr]-MacPart.bin /mtd_swu/  >> $FFBLOG 2>&1 
#	echo "[`date +%H:%M:%S`] MacPart.bin copied to /mtd_swu/ successfully!"  >> $FFBLOG 2>&1

#Checking macPart hashes
md5=$( $CUR_DIR/md5sum $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin )
	echo $md5 > /mtd_swu/MacPart.md5
	if [ $( grep -c "$md5_MacPart" /mtd_swu/MacPart.md5 ) -gt 0 ]; then
		echo "MacPart.bin chksum OK" >> $FFBLOG 2>&1
	else
		echo "ERROR. MacPart.bin chksum wrong. !!!" >> $FFBLOG 2>&1
		touch /mtd_swu/MacPart_error
		_Func_Error	
	fi
	
	echo "[`date +%H:%M:%S`] Start flashing $MAC_PART"  >> $FFBLOG 2>&1 
	touch /mtd_swu/macpart_flash_start	
	bml.restore $MAC_PART $CUR_DIR/macpart/[$firmware_usb-$fw_nr]-MacPart.bin  > $USB/MacPart.log 2>&1
	touch /mtd_swu/macpart_flash_ok
	echo "[`date +%H:%M:%S`] $MAC_PART flashed!"  >> $FFBLOG 2>&1 
#	rm -rf /mtd_swu/[$firmware_usb-$fw_nr]-MacPart.bin
#	echo "[`date +%H:%M:%S`] MacPart.bin deleted from /mtd_swu/"  >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync

#Toggle - if all ok, activate alternative firmware
	echo "########## Switching to alternative firmware ##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	touch $PART_FLAG_ALT 				>> $FFBLOG 2>&1 
	echo "$PART_FLAG_ALT created." 		>> $FFBLOG 2>&1 
	echo "Writing firmware ID to $VERSION_ALT..." >> $FFBLOG 2>&1 
		cat $USB/$image_dir/version_info.txt > $VERSION_ALT >> $FFBLOG 2>&1 
			if [ -e /mtd_rwarea/Version_1_SIG ] ; then
					cat $USB/$image_dir/version_info.txt > /mtd_rwarea/Version_1_SIG >> $FFBLOG 2>&1
					echo "Version_1_SIG created." >> $FFBLOG 2>&1 
			fi
	echo "$VERSION_ALT created" >> $FFBLOG 2>&1 
	rm -rf $PART_FLAG
	echo "$PART_FLAG removed."		>> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync

############ Finito ############
echo " " >> $FFBLOG 2>&1
touch /mtd_swu/5_end_ok # message procedure finish
echo "USB update end !!!" >> $FFBLOG 2>&1 
echo "USB update end !!!"
sleep 10

#clean /mtd_swu
set +e
echo "cleaning /mtd_swu/" 
rm -rf /mtd_swu/* 
echo "/mtd_swu/ cleaned." 
set -e

echo " " >> $FFBLOG 2>&1
end=`date +%s`
diff=`expr $end - $start`
echo "========================">> $FFBLOG 2>&1 
echo "|Duration = $diff seconds|">> $FFBLOG 2>&1 
echo "========================">> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1
echo "Welcome to pre-FEB world !!!" >> $FFBLOG 2>&1 
echo "========================FFB end !!!========================"
echo "========================FFB end !!!========================"
echo "========================FFB end !!!========================"
echo " " >> $FFBLOG 2>&1
echo "TV is rebooting right now. Bye :)" >> $FFBLOG 2>&1 
/mtd_boot/MicomCtrl 143  
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143